<?php
/*
 * This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. 
 *
 * an5w is always available at http://metanohi.org/projects/an5w/, along
 * with documentation. an5w was created by Niels Serup (ns@metanohi.org).
 */

// Version 0.001

function get($file) {
	$content = @file_get_contents($file);
	$content = trim($content);
	if ($content == '')
		return false;
	else
		return $content;
}
$nothing_symbol = '`';
$text_identifier = '/TEXT/';

$title = get('title') or $title = 'Survey';
if ($title == $nothing_symbol)
	$title = '';
if (!$_POST && !$_GET) {
	$header = get('header') or $header = '<h1>Survey</h1>';
	if ($header == $nothing_symbol)
		$header = '';

	$questions = get('questions') or $questions = '';
	$questions = str_replace("\r", "\n", str_replace("\r\n", "\n", $questions));
	$questions = explode("\n\n", $questions);

	$textareas = 0;

	$text = "$header\n<form method='post' action=''>\n";
	foreach ($questions as $q) {
		$spl = explode("\n", $q);
		$text .= "<p>{$spl[0]}</p>\n";
		array_splice($spl, 0, 1);
		foreach ($spl as $p) {
			if ($p == '[]') {
				$textareas++;
				$text .= "<textarea name='text$textareas'></textarea>\n";
				break;
			}
		}
	}

	$button_text = get('button') or $button_text = 'Submit';
	$text .= "<p id='submit'><input type='submit' value='$button_text' /></p>\n</form>\n";
}
else if ($_POST) {
	$post = array();
	for ($i = 0; $i < sizeof($_POST); $i++) {
		$key = key($_POST);
		if ($_POST[$key] == '')
			$post[$key] = $nothing_symbol;
		else
			$post[$key] = $_POST[$key];
		next($_POST);
	}
	
	while ($c = current($post)) {
		$key = key($post);
		$c = strip_tags($c, '<a><b><i><u>');
		$c = str_replace("\n", '<br />', str_replace("\r", "\n", str_replace("\r\n", "\n", $c)));
		$c .= "\n";
		$f = fopen("answers/$key", 'a');
		fwrite($f, $c);
		fclose($f);
		next($post);
	}
	
	header('Location: ?done');
	die();
}
else if ($_GET) {
	$done = get('done') or $done = "<h1>The information has been sent.</h1>\n";
	$text = $done;
}

$footer = get('footer') or $footer = '';
	$text .= "$footer\n";

$wrapper = get('wrapper') or $wrapper = "<div id='wrapper'>\n$text_identifier</div>\n";
if (strpos($wrapper, $text_identifier) !== false)
$text = str_replace($text_identifier, $text, $wrapper);

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns='http://www.w3.org/1999/xhtml'>
<!--
	This survey was created semi-automatically by an5w, a PHP program.
	
	This program is free software. It comes without any warranty, to
	the extent permitted by applicable law. You can redistribute it
	and/or modify it under the terms of the Do What The Fuck You Want
	To Public License, Version 2, as published by Sam Hocevar. See
	http://sam.zoy.org/wtfpl/COPYING for more details.
	
	an5w is always available at http://metanohi.org/projects/an5w/, along
	with documentation. an5w was created by Niels Serup (ns@metanohi.org).
-->
	<head>
		<title><?php echo $title; ?></title>
		<meta http-equiv='content-type' content='text/html; charset=utf-8' />
		<link href='style.css' type='text/css' rel='stylesheet' />
	</head>
	
	<body>
<?php echo $text; ?>
	</body>
</html>
