/*
 * Enigma: an interpreter for the Enigma language
 * Copyright (C) 2010  Niels Serup

 * This file is part of Enigma.

 * Enigma is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Enigma is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Enigma.  If not, see <http://www.gnu.org/licenses/>.
 */

package enigma;

import java.util.ArrayList;

/**
 * A modified ArrayList to keep variables in hierarchy (globals > 1 > 2 etc.)
 * @author  Niels Serup <ns@metanohi.org>
 * @version 0.1
 */
public class EnigmaVariableDictList extends ArrayList<EnigmaVariableDict> {
    private static final long serialVersionUID = 1L;

    public EnigmaVariableDict addDict() {
        EnigmaVariableDict dict = new EnigmaVariableDict();
        add(0, dict);
        return dict;
    }
    
    public void pop() {
        remove(0);
    }

    public EnigmaVariable getVariable(String name) {
        for (EnigmaVariableDict x : this) {
            EnigmaVariable var = x.getVariable(name);
            if (var != null)
                return var;
        }
        // Else
        return null;
    }
}
