#include <stdio.h>
#include <stdlib.h>
#define MAXCHARS_DEFAULT 3

unsigned int str_len(const char *str) {
	unsigned int len = 0;
	while (*str != '\0') {
		++str;
		++len;
	}
	return len;
}

void str_cpy(char *dest, const char *src, unsigned int bytes) {
	unsigned int i;
	for (i = 0; i < bytes; i++) {
		*dest = *src;
		++dest;++src;
	}
}

int main(int argc, char *argv[]) {
	unsigned int maxchars, string_length, diff, i;
	char *string;
	
	if (argc < 3) {
		maxchars = MAXCHARS_DEFAULT;
	}
	else {
		maxchars = atoi(argv[2]);
		if (maxchars == 0)
			maxchars = MAXCHARS_DEFAULT;
	}
	
	if (argc < 2) {
		string = malloc(2);
		*string = '0';++string;*string='\0';--string;
	}
	else {
		string_length = str_len(argv[1])+1;
		string = malloc(string_length);
		str_cpy(string, argv[1], string_length);
	}
	
	string_length = str_len(string);
	if (string_length < maxchars) {
		diff = maxchars - string_length;
		string = realloc(string, maxchars);
		for (i = maxchars-1; i > diff-1; i--) {
			string[i] = string[i-diff];
		}
		for (i = 0; i < diff; i++) {
			string[i] = ' ';
		}
	}
	
	printf("%s", string);
    free(string);
	return 0;
}
