#include <stdio.h>
#include <stdlib.h>
#define MAXCHARS_DEFAULT 76
#define NUMBER_OF_DOTS    3

unsigned int str_len(const char *str) {
	unsigned int len = 0;
	while (*str != '\0') {
		++str;
		++len;
	}
	return len;
}

void str_cpy(char *dest, const char *src, unsigned int bytes) {
	unsigned int i;
	for (i = 0; i < bytes; i++) {
		*dest = *src;
		++dest;++src;
	}
}

int main(int argc, char *argv[]) {
	unsigned int maxchars, string_length, diff, part, i;
	char *string, *orig_string;
	
	if (argc < 3) {
		maxchars = MAXCHARS_DEFAULT;
	}
	else {
		maxchars = atoi(argv[2]);
		if (maxchars == 0)
			maxchars = MAXCHARS_DEFAULT;
		if (maxchars < NUMBER_OF_DOTS + 2)
			maxchars = NUMBER_OF_DOTS + 2;
	}
	
	if (argc < 2) {
		orig_string = NULL;
		string_length = 0;
	}
	else {
		orig_string = argv[1];
		string_length = str_len(argv[1]);
	}
	
	string = malloc(maxchars+1);
	string[maxchars] = '\0';
	
	if (string_length <= maxchars) {
		str_cpy(string, orig_string, string_length);
		for (i = string_length; i < maxchars; i++) {
			string[i] = ' ';
		}
	}
	else {
		diff = string_length - maxchars + NUMBER_OF_DOTS;
		part = (maxchars - NUMBER_OF_DOTS);
		if (part % 2 == 0)
			part /= 2;
		else
			part = part / 2 + 1;
		
		str_cpy(string, orig_string, part);
		string += part;
		for (i = 0; i < NUMBER_OF_DOTS; i++) {
			*string = '.';++string;
		}
		orig_string += part + diff;
		part = maxchars - part - NUMBER_OF_DOTS;
		str_cpy(string, orig_string, part);
		string -= (maxchars - part);
	}
	
	printf("%s", string);
	free(string);
	return 0;
}
