#!/usr/bin/env python

#   Semi-random sentence generator using Wordwork
#   Copyright (C) 2010  Niels Serup
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Maintained by Niels Serup <ns@metanohi.org>

### Generates a sentence with random words from a random template ###

# Imports
import random
import time
import sys
import wordworklib.client as client

sentence_templates = (
    "The &O are &p the &n.",
    "&P will &v &P.",
    "The &n &D &t.",
    "The &n &D &t to &P.",
    "I am &j.",
    "Being &j doesn't mean you can &v.",
    "Your name is.. &P!",
    "The &n is &c than the &n.",
    "Are you the &s &n?",
    "It &t!",
    "I would've &o the &O.",
    "&O &v &d.",
    "Yes, that's &c.",
    "No, that's not &c.",
    "Is &p &O a good idea?",
    "Do not &v &O (or &P \& &P).",
    "Have you heard of &P \& &P?",
    "Believing that &p is &j isn't &j.",
    "&d he &t the &n.",
    "The &O were not &l.",
    "This is &c than the &s organization of &O.",
    "I &D &v how I &d &o the &O.",
    "Do not trust &P!",
    "I have &l now.",
    "It is &j to &v &d, but not to do it &d.",
    "'&n' is not a verb; neither is '&j'."
)

try: host = sys.argv[1]
except: host = '127.0.0.1'
try: port = sys.argv[2]
except: port = 51346

clt = client.WordworkClient(host, port)
clt.start()
while 1:
    msg = clt.parse_letters(random.choice(sentence_templates))
    print msg[0].upper() + msg[1:]
    time.sleep(1)
