#!/usr/bin/env python

#   wordwork: a system meant to create sentences using random words
#   Copyright (C) 2010  Niels Serup
#
#   This file is part of wordwork.
#
#   wordwork is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   wordwork is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with wordwork.  If not, see <http://www.gnu.org/licenses/>.
#
#   Maintained by Niels Serup <ns@metanohi.org>
#
#     ===========================================
#   || Documentation and downloads are available ||
#   || at http://metanohi.org/projects/wordwork/ ||
#     ===========================================

### CLIENT STARTER ###

# Imports
import sys
from os.path import realpath, dirname
import optparse
import wordworklib.client as client

usage = "usage: %prog [option]... [file]\nStarts a Wordwork server"
version = """\
wordwork 0.1
Copyright (C) 2010  Niels Serup
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.\
"""

parser = optparse.OptionParser(usage=usage, version=version)
parser.add_option("-p", "--port", dest="port", default=51346,
                  type="int", help="port number to use")
parser.add_option("-H", "--host", dest="host", default="127.0.0.1", type="string",
                  help="hostname to use")
parser.add_option("-t", "--text", dest="text", default="", type="string",
                  help="wordwork text (overwritten if a file is specified)")
(options, args) = parser.parse_args()
if len(args) < 1 and not options.text:
    parser.error('no text specified')

try:
    f = open(args[0], 'U')
    text = f.read()
    f.close()
except Exception:
    text = options.text

try:
    clt = client.WordworkClient(options.host, options.port)
    clt.start()
    print clt.parse(text)
except (KeyboardInterrupt, EOFError):
    print # A newline
