#!/usr/bin/env python

#   wordwork: a system meant to create sentences using random words
#   Copyright (C) 2010  Niels Serup
#
#   This file is part of wordwork.
#
#   wordwork is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   wordwork is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with wordwork.  If not, see <http://www.gnu.org/licenses/>.
#
#   Maintained by Niels Serup <ns@metanohi.org>
#
#     ===========================================
#   || Documentation and downloads are available ||
#   || at http://metanohi.org/projects/wordwork/ ||
#     ===========================================

### EXTRACTOR STARTER ###

# Imports
import sys
from os.path import realpath, dirname
import optparse
import wordworklib.extractor as extractor

usage = "usage: %prog infile [outfile]\nCreates a dictionary from Wiktionary XML"
version = """\
wordwork 0.1
Copyright (C) 2010  Niels Serup
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.\
"""

parser = optparse.OptionParser(usage=usage, version=version)
(options, args) = parser.parse_args()
if len(args) < 1:
    parser.error('no infile specified')
else:
    infile = open(args[0], 'U')
    if len(args) > 1:
        outfile = open(args[1], 'w')
    else:
        outfile = sys.stdout

try:
    extractor.parse(infile, outfile)
except (KeyboardInterrupt, EOFError):
    print # A newline
