#!/usr/bin/env python

#   wordwork: a system meant to create sentences using random words
#   Copyright (C) 2010  Niels Serup
#
#   This file is part of wordwork.
#
#   wordwork is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   wordwork is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with wordwork.  If not, see <http://www.gnu.org/licenses/>.
#
#   Maintained by Niels Serup <ns@metanohi.org>
#
#     ===========================================
#   || Documentation and downloads are available ||
#   || at http://metanohi.org/projects/wordwork/ ||
#     ===========================================

### CLIENT ###

# Imports
import socket
import random
import re

class WordworkClient:
    def __init__(self, host='127.0.0.1', port=51346):
        self.host = host
        self.port = port

    def start(self):
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.s.connect((self.host, self.port))
        self.s.send('!')
        self.size = eval(self.s.recv(1024))

    def parse(self, text):
        vals = re.findall(r'\$\(([A-Za-z]+)\s+(".*?")\)', text, re.S)
        data = {}
        for x in vals:
            data[x[0]] = self.parse_letters(eval(x[1]))
        text = re.sub(r'(?s)\$\([A-Za-z]+\s+".*?"\)\n?', '', text)
        def repl(matchobj):
            try:
                return data[matchobj.group(1)]
            except Exception:
                return ''
        text = re.sub(r'#(.*?)#', repl, text)
        return self.parse_letters(text)

    def parse_letters(self, text):
        size = self.size
        s = self.s
        l = len(text)
        ntext = ''
        tmp = []
        i = 0

        while i < l:
            c = text[i]
            if c == '&':
                tmp.append(text[i+1])
                i += 1
                ntext += '%s'
            elif c == '\\':
                ntext += text[i+1]
                i += 1
            else:
                ntext += c
            i += 1

        tmp2 = ''
        for x in tmp:
            tmp2 += x + str(random.randint(0, size[x]-1)) + ';'
        tmp2 = tmp2[:-1]
        if tmp2:
            s.send(tmp2[:-1])
            words = eval(s.recv(1024))
            msg = ntext % tuple(words)
        else:
            msg = ntext
        return msg
