#!/usr/bin/env python

#   wordwork: a system meant to create sentences using random words
#   Copyright (C) 2010  Niels Serup
#
#   This file is part of wordwork.
#
#   wordwork is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   wordwork is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with wordwork.  If not, see <http://www.gnu.org/licenses/>.
#
#   Maintained by Niels Serup <ns@metanohi.org>
#
#     ===========================================
#   || Documentation and downloads are available ||
#   || at http://metanohi.org/projects/wordwork/ ||
#     ===========================================

### WORD EXTRACTOR ###

# Imports
import sys
import re

############################# % % % % % % % % % % % % %
# WARNING: UGLY CODE AHEAD! # (must be fixed sometime) %
############################# % % % % % % % % % % % % %

# ONLY DETECTION FOR ENGLISH WORDS (currently)
# Data
_info = {
    '{{en-adj': 'j',                   # Adjective
    ### The software was finally >>free<<.
    '{{comparative of': (
        ('Adjective', 'c'),            # Comparative form of adjective
        ('Adverb', 'C')),              # Comparative form of adverb
    ### Adjective: This was >>funnier<< than last time.
    ### Adverb: The film played earlier.
    '{{superlative of': (
        ('Adjective', 's'),            # Superlative form of adjective
        ('Adverb', 'S')),              # Superlative form of adverb
    ### Adjective: That pie is the >>tastiest<< I've ever had.
    ### Adverb: You can do best!
    ('{{en-adv', (1, '|-')): 'D',      # Not comparable adverbium
    ### The spaceships >>always<< disappear.
    ('{{en-adv', (0, '|-')): 'd',      # Adverbium
    ### The driver drove >>slowly<<.
    '{{en-verb': 'v',                  # Verb
    ### He was asking when to >>eat<<.
    '{{third-person singular of': 't', # Third-person singular form of verb
    ### She >>eats<<.
    '{{present participle of': 'p',    # Present participle form of verb
    ### The lion was >>eating<< something.
    '{{past participle of': 'l',       # Past participle form of verb
    ### The gazelle was >>eaten<<.
    '{{past of': 'o',                  # Past form of verb
    ### He >>killed<< the program.
    '{{en-noun': 'n',                  # Noun
    ### The >>keyboard<< was different.
    '{{plural of': 'O',                # Plural form of noun
    ### He gave away >>flowers<<.
    '{{en-proper noun': 'P',           # Proper noun
    ### Her name was >>Cleopatra<<.
    '{{infl|en|preposition': 'i'       # Preposition
    ### I am >>on<< the wastebin.
}

_infok = _info.keys()

# Function
def parse(infile, outfile=sys.stdout):
    # Particles and probably some
    # other things as well are not included.
    info = _info
    infok = _infok
    tmp = []
    title = ''
    inlang = False
    current_subsection = ''

    for line in infile:
        matchobj = re.match(r'===(.*?)===', line)
        if title == '':
            t = line.find('<title>')
            if t != -1 and line.find(':') == -1:
                t += 7
                title = line[t:line.find('<', t)]
        elif matchobj is not None:
            current_subsection = matchobj.group(1)
        elif line.find('==English==') != -1:
            inlang = True
        elif (re.match(r"[^=]+==[^=]+==\s*$", " " + line) is not None \
              and inlang) or line.find('</text>') != -1:
            title = ''
            inlang = False
            for x in tmp:
                outfile.write(x+'\n')
            tmp = []
        elif inlang:
            for x in infok:
                try:
                    l = line.find(x)
                    typ = 1
                except Exception:
                    l = line.find(x[0])
                    typ = 2
                if l != -1:
                    txt = ''
                    if typ == 1:
                        txt = info[x]
                        try:
                            txt += title
                        except Exception:
                            loop = txt
                            txt = ''
                            for y in loop:
                                if y[0] == current_subsection:
                                    txt = y[1] + title
                                    break
                    else:
                        end = line.find('}}', l)
                        if end != -1:
                            sstr = line[l:l+end]
                            tests = x[1:]
                            ok = True
                            for y in tests:
                                cond = y[0]
                                testfor = y[1]
                                if (cond == 0 and sstr.find(testfor) != -1) \
                                        or (cond == 1 and
                                            sstr.find(testfor) == -1):
                                    ok = False
                                    break
                            if ok:
                                txt = info[x] + title
                        #else:
                        #    sys.stderr.write("error on line; missing }} (probably on next line)")
                    if txt and txt not in tmp:
                        tmp.append(txt)
