#!/usr/bin/python
import re

def format_var(matchobj, skip = 1):
    try: txt = matchobj.group()
    except: txt = matchobj
    if skip:
        txt = txt[1:]
    if txt[-1] == '<':
        txt = txt[:-1]
    spl = txt.split('.')
    txt = spl[0]
    if txt == 'this':
        global current_type
        txt = current_type + "[c" + current_type + "]"
    spl = spl[1:]
    for x in spl:
        txt += '["' + x + '"]'
    
    if skip:
        ntxt = "'+" + txt + "+'"
    else:
        ntxt = txt
    return ntxt

def change_var_names(txt):
    return re.sub(r'\$(\w\.?)+<?', format_var, txt).replace(r"+'\<", "+'<")

def process_string(txt):
    #print txt
    l = re.match(r"(\s*)!(.+)", txt)
    if l:
        g = l.groups()
        global quot_level
        return g[0] + 'p("' + change_var_names(g[1]) + '")'
    
    l = re.match(r"(.+)\s*'=\s*!(.*)", txt)
    if l:
        g = l.groups()
        return format_var(g[0].strip(), 0) + '="p(\'' + change_var_names(g[1]) + '\')"'
    
    l = re.match(r"(\s*)(.+)\s*'=\s*(.+)", txt)
    if l:
        global quot_level
        #quot_level += 1
        g = l.groups()
        return g[0] + format_var(g[1].strip(), 0) + '=' + "'" + change_var_names(g[2]) + "'"
    
    l = re.match(r"(\s*)(.+)\s*=\s*(.+)", txt)
    if l:
        g = l.groups()
        return g[0] + format_var(g[1].strip(), 0) + '=' + change_var_names(g[2])
    
    l = re.match(r"(\s*)(.+)\s*=\s*", txt)
    if l:
        g = l.groups()
        return g[0] + format_var(g[1].strip(), 0) + '={'
    
    return change_var_names(txt)

cfile = open('d', 'r').read()
lines = cfile.split('\n')

dict_level = 0
quot_level = 0
current_type = ''
code = ''
for x in lines:
    if not x.strip(): continue
    
    l = re.match(r"<(\w+)\s(\w+)", x)
    if l:
        g = l.groups()
        code += '\n' + g[0] + '["' + g[1] + '"]={\n'
        current_type = g[0]
        dict_level = 1
        continue
    l = re.match(r"\s*(\w+)\s*:\s*/", x)
    if l:
        g = l.groups()
        code += "'" + g[0] + "':\n" + ('\\' * quot_level + '"') * 3 + '\n'
        quot_level += 1
        continue
    l = re.match(r"\s*(\w+)\s*:\s*(.+)", x)
    if l:
        g = l.groups()
        code += "'" + g[0] + "':'" + process_string(g[1]) + "',\n"
        continue
    l = re.match(r"\s*(\w+)\s*:\s*", x)
    if l:
        g = l.groups()
        if g[0] == 'else':
            code += 'else:\n'
        else:
            code += '"' + g[0] + '":{\n'
            dict_level += 1
        continue
    if x.strip() == '>':
        dict_level -= 1
        if not dict_level:
            comma = ','
        else:
            comma = ''
        code += '}' + comma + '\n'
        continue
    if x.strip() == '/':
        quot_level -= 1
        code += ('\\' * quot_level + '"') * 3 + ',\n'
        continue
    
    code += process_string(x).replace("''+", "").replace("+''", "") + '\n'
    
code = (code + '\n').replace(",\n}", "\n}").replace("\n},\n\n", "\n}\n\n").strip()
#print code
open('n', 'w').write(code)
